<template>
    <div class="q-gutter-y-lg full-width">

        <q-select
            :options="WorkerChartType"
            emit-value
            map-options
            label-slot
            filled
            v-model="routeQueries.type">
            <template v-slot:label>
                <LabelSlot icon="icofont-dashboard-web" label="Chart Type"
                           tooltip="The chart to type to visualize the analytics"/>
            </template>

            <template v-slot:option="scope">
                <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                    <q-item-section avatar>
                        <q-icon :name="scope.opt.icon"/>
                    </q-item-section>
                    <q-item-section>
                        <q-item-label>
                            {{ scope.opt.label }}
                        </q-item-label>
                    </q-item-section>
                </q-item>
            </template>
        </q-select>

        <q-toggle v-model="range" label="Specify date range" icon="date_range"/>
        <q-toggle v-model="merge" label="Merge Zones" icon="call_merge"/>
        <q-input v-if="range" filled v-model="stringModel" mask="####/##/## - ####/##/##">
            <template v-slot:append>
                <q-icon name="event" class="cursor-pointer">
                    <q-popup-proxy ref="qDateProxy" transition-show="scale" transition-hide="scale">
                        <q-date v-model="dateModel" range :events="days">
                            <div class="row items-center justify-end">
                                <q-btn v-close-popup label="Close" color="primary" flat/>
                            </div>
                        </q-date>
                    </q-popup-proxy>
                </q-icon>
            </template>
        </q-input>
        <q-toggle v-if="routeQueries.type === 'line' && merge" label="Specify floor" v-model="specifyFloor"/>
        <q-select v-if="routeQueries.type === 'line' && merge && specifyFloor"
                  emit-value
                  map-options
                  label-slot
                  filled
                  :options="floors"
                  option-label="name"
                  option-value="id"
                  v-model="routeQueries.floorId"
        >
            <template v-slot:label>
                <LabelSlot icon="layer" label="Floor"
                           tooltip="The floor to scope to"/>
            </template>
        </q-select>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import FormCore from "components/FormCore.vue";
import LabelSlot from "components/LabelSlot.vue";
import {WorkerGraphType} from "src/classLibrary/Charting/WorkerChart";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";

@Component({
    components: {LabelSlot, FormCore}
})
export default class FloorChartOptions extends Vue {
    routeQueries = {
        startTime: '',
        endTime: '',
        range: 'false',
        merge: 'true',
        type: '',
        floorId: '',
        specifyFloor: 'false',
    }

    get specifyFloor() {
        return this.routeQueries.specifyFloor === 'true';
    }

    set specifyFloor(r: boolean) {
        this.routeQueries.specifyFloor = r ? 'true' : 'false';
    }

    get merge() {
        return this.routeQueries.merge === 'true';
    }

    set merge(r: boolean) {
        this.routeQueries.merge = r ? 'true' : 'false';
    }

    get range() {
        return this.routeQueries.range === 'true';
    }

    set range(r: boolean) {
        this.routeQueries.range = r ? 'true' : 'false';
    }

    @Prop() days!: string[];
    @Prop() floors!: FloorPrincipalResponse[];

    get WorkerChartType() {
        return WorkerGraphType;
    }


    get dateModel(): { from: string, to: string } | string {
        if (this.routeQueries.startTime === this.routeQueries.endTime) {
            return this.routeQueries.startTime;
        }
        return {
            from: this.routeQueries.startTime,
            to: this.routeQueries.endTime,
        }
    }

    get stringModel() {
        return `${this.routeQueries.startTime} - ${this.routeQueries.endTime}`;
    }

    set stringModel(d: string) {
        const [from, to] = d.split('-').Map(x => x.trim());
        this.routeQueries.startTime = from;
        this.routeQueries.endTime = to;
    }

    set dateModel(model: { from: string, to: string } | string) {
        if (model == null) return;
        if ((model as any).from) {
            model = model as { from: string, to: string }
            this.routeQueries.startTime = model.from
            this.routeQueries.endTime = model.to
        } else {
            this.routeQueries.startTime = model as string;
            this.routeQueries.endTime = model as string;
        }
    }
}
</script>

<style lang='scss' scoped>

</style>
